require 'sketchup.rb'
# Copyright 2010, <jim.foltz@gmail.com>
#
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
#  Thanks to TIG for the amazing everpresent help!

#   Original script by Jim Foltz  -  22.05.2013  -  modified and updated by CadFather for Sketchup 2013 - flipping heck!   ; )


#------------------------------------------------------------------   SAVE 2013 as v8



module JF
    def self.save_as_previous_version
        title = Sketchup.active_model.title
        if title == ""
            UI.messagebox("Model must be saved before it can be saved as the previous version.", MB_OK, 1)
			
			Sketchup.send_action( 57603 )
			
            return
			else
		
			
			
        end
        script_file = File.join(ENV["TEMP"], "jf_save_as_prev_version.vbs")
        unless File.exists?(script_file) 
            script  = %[Set WshShell = WScript.CreateObject("WScript.Shell")\n]
            script += %[Set WshShell = WScript.CreateObject("WScript.Shell")
WshShell.SendKeys "%fa"
WScript.Sleep 200
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "_v8"
WshShell.SendKeys "%t"
WshShell.SendKeys "s"
WshShell.SendKeys "{ENTER}"]
            File.open(script_file, "w") { |f| f.puts(script) }
        end
        UI.openURL("file:///"+script_file)
    end
end


#------------------------------------------------------------------   SAVE 8 AS..  (dialog box)


module JF2
    def self.save_as_previous_version
        title = Sketchup.active_model.title
        script_file2 = File.join(ENV["TEMP"], "jf_save_as_prev_version2.vbs")
        unless File.exists?(script_file2) 
            script  = %[Set WshShell = WScript.CreateObject("WScript.Shell")\n]
            script += %[Set WshShell = WScript.CreateObject("WScript.Shell")
WshShell.SendKeys "%fa"
WScript.Sleep 200
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "{LEFT}"
WshShell.SendKeys "_v8"
WshShell.SendKeys "%t"
WshShell.SendKeys "s"]
            File.open(script_file2, "w") { |f| f.puts(script) }
        end
        UI.openURL("file:///"+script_file2)
    end
end

#------------------------------------------------------------------   SAVE OVER 8

module JF3
    def self.save_as_previous_version
        title = Sketchup.active_model.title
        script_file3 = File.join(ENV["TEMP"], "jf_save_as_prev_version3.vbs")
        unless File.exists?(script_file3) 
            script  = %[Set WshShell = WScript.CreateObject("WScript.Shell")\n]
            script += %[Set WshShell = WScript.CreateObject("WScript.Shell")
WshShell.SendKeys "%fa"
WScript.Sleep 200
WshShell.SendKeys "%t"
WshShell.SendKeys "s"
WshShell.SendKeys "{ENTER}"
WshShell.SendKeys "y"]
            File.open(script_file3, "w") { |f| f.puts(script) }
        end
        UI.openURL("file:///"+script_file3)
    end
end







# Menu

if( not file_loaded? "jfsave8.rb" )

tb = UI::Toolbar.new("Save8")

cmdx1 = UI::Command.new("Save V8") { JF.save_as_previous_version }
cmdx1.small_icon = '#_ICONS/save_16.png'
cmdx1.large_icon = '#_ICONS/save_24.png'
cmdx1.tooltip=cmdx1.status_bar_text=cmdx1.menu_text=  'Save File as Version 8 (SAVE)'
tb.add_item(cmdx1)

cmdx2 = UI::Command.new("Save V8 as...") { JF2.save_as_previous_version }
cmdx2.small_icon = '#_ICONS/saveas_16.png'
cmdx2.large_icon = '#_ICONS/saveas_24.png'
cmdx2.tooltip=cmdx2.status_bar_text=cmdx2.menu_text=  'Save File as Version 8 (SAVE AS...)'
tb.add_item(cmdx2)

cmdx3 = UI::Command.new("Save V8 >") { JF3.save_as_previous_version }
cmdx3.small_icon = '#_ICONS/saveov_16.png'
cmdx3.large_icon = '#_ICONS/saveov_24.png'
cmdx3.tooltip=cmdx3.status_bar_text=cmdx3.menu_text=  'Save File as Version 8 (SAVE AS...)'
tb.add_item(cmdx3)

#------------

UI.menu("File").add_item("Save V8") { JF.save_as_previous_version }
UI.menu("File").add_item("Save V8 as...") { JF2.save_as_previous_version }
UI.menu("File").add_item("Save V8 >") { JF3.save_as_previous_version }



end  #Menu


file_loaded("jfsave8.rb")